; USGDOS v0.8 
;for usgard v0.95b
;
;size: 437 bytes
;
;new in this version:
;completely redid interface
;mem dispalyed in title bar
;
;commands:
; DIR - D
; CLS - C
; OFF - O
; DEL - R

#include "usgard.h"             ; like I need to explain this
#include "lib/usgdlib.h"        ; for string input
#include "lib/displib.h"        ; for displaying hl in decimal in menu text

cmdline = $808D ; where qview looks for the var name
                ; also where stuff typed in at the command line is stored

;;;;
;mem locations for DIR
;;;;
counter = TEXT_MEM

.org 0
desc:
.db "USGDOS v0.8",0            ; title string
.db USGDLIB,DISPLIB,0          ; libs used

Start:
        call    CLEARLCD
        ld      hl, $0600
        ld      ($8333), hl
RunProgram:
        set     3, (IY+05)
        ld      hl, ($8333)
        push    hl
        ld      hl, VIDEO_MEM   ;copied from
        ld      de, VIDEO_MEM+1 ;ugnix.asm
        ld      (hl), 255       ;by
        ld      bc, 111         ;Bill
        ldir                    ;Roehl
	ld      hl, $0001
        ld      ($8333), hl
        ld      hl, &desc       ; relocation to get address of description
        call    D_ZM_STR        ; print description
        ld      hl, $0049
        ld      ($8333), hl
        call    FREEMEM
        sub     a
        LIB_CALL_(6,0)          ; D_SET
        LIB_CALL_(6,4)          ; D_HL_DEC
        ld      hl, &MEM_PROMPT
        call    D_ZM_STR
        pop     hl              ; restore
        ld      ($8333), hl     ; (CURSOR_X)
        ld      hl, VIDEO_MEM+880       ; draw box
        ld      de, VIDEO_MEM+880+1     ; for command prompt
        ld      (hl), $FF               ;
        ld      bc, 143                 ;
        ldir                            ;
        ld      hl, $0007       ;\
        ld      ($800C),hl      ;-set textpos
        ld      hl, &Prompt     ; relocation to get address of prompt
        call    D_ZT_STR        ; display the prompt
        ld      ix, cmdline     ; ix is where the string will be stored
        ld      c, 8            ; max len 8 characters
        ld      a, 16           ; set cursor type to ALPHA
        LIB_CALL_(1,0)          ; (USGDLIB,INPST)  ; string input function
        ld      a, ' '          ; HAH!
        call    TX_CHARPUT      ; no more ghost cursors
        res     3, (IY+05)
        ld      a, (IX)         ; check to see if exit was
        and     a               ; pressed during string input
        ret     z               ; if so, exit
Exec:
        ld      hl, cmdline     ; point to name of var to be run
        call    VAR_EXEC        ; run it
        jr      nc, Executed    ; if executed ok goto Executed
Command:                        ; checks for internal Usgdos commands
        ld      hl, cmdline     ; point to command line
        ld      ix, &DIR        ; pointer to "D",0
        call    &Cp_Str         ; compare strings
        call    z, &Cdir        ; if same call dir
        jp      z, &RunProgram  ; and go up to beginning
        ld      hl, cmdline     ; see above
        ld      ix, &CLS        ; see above
        call    &Cp_Str         ; see above
        jp      z, &Start       ; see above
        ld      hl, cmdline     ; ...
        ld      ix, &OFF        ; ...
        call    &Cp_Str         ; ...
        call    z, &Coff        ; ...
        jp      z, &RunProgram  ; ...
        ld      hl, cmdline     ; ...
        ld      ix, &DEL        ; ...
        call    &Cp_Str         ; ...
        call    z, &Cdel        ; ...
        jp      z, &RunProgram  ; ...
Errors:
        ld      hl, cmdline     ; point to cmdline
        call    VAR_GET         ; only used to check if exist var
        jr      c, Errormsg     ; if carry then var not found, and show error
        ld      hl, &QVIEW      ; try using qview
        call    VAR_EXEC        ; run qview
        jr      nc, Executed    ; qview ran
Errormsg:
        call    &Nextline       ; next line
        ld      hl, &Error      ;\ display error message
        call    D_ZM_STR        ;/
        jp      &RunProgram     ; go back to beginning
Executed:
        ld      a, (USG_BITS)   ; check USG_BITS
        bit     1, a            ; check for warp out
        ret     nz              ; warp out
        jp      &Start          ; back to VERY beginning

;;;;
;begin sub functions not part of main program loop
;;;;

Cp_Str:
;compares a string at (ix)
;with a string at (hl)
;until different or (ix) = $00
;a, b, hl, ix, f destroyed
; Case       Z flag       C flag
; A < D          0           0
; A = D          1           0
; A > D          0           1

; call    ASCIIZ_LEN when I have more info about it

        ld      a, (ix)         ;get byte from first string
        and     a               ;make sure it is not 0
        jr      z, zero         ;if 0 goto zero
        ld      b, (hl)         ;get byte from second string
        cp      b               ;compare byte from first string with second $
        ret     nz              ;no natch ... bye
        inc     ix              ;next byte (string1)
        inc     hl              ;next byte (string2)
        jr      Cp_Str
zero:
        cp      (hl)
        ret

Nextline:
        ld      hl, ($8333)
        ld      l, 1              ; beginning of line
        ld      a, h
        cp      48                ; last line?
        jr      z, s_up           ; scroll up
        add     a, 6              ; next line
        ld      h, a
        ld      ($8333),hl        ; set textpos
        ret                       ; go back to where it was called
s_up:
        ld      h, a
        ld      ($8333), hl
        ld      hl, VIDEO_MEM+288
        ld      de, VIDEO_MEM+192
        ld      bc, 112*6
        ldir
        push    de
        pop     hl
        dec     de
        ld      bc, 96
        ld      (hl), 0
        LDDR
        ret

;;;;
;commands
;;;;

Coff:                            ;turns the calculator off
        push    af
        call    OTH_SHUTDOWN
        pop     af
        ret

Cdel:
        push    af
        set     3, (IY+05)
        ld      hl, VIDEO_MEM+880       ; draw box
        ld      de, VIDEO_MEM+880+1     ; for command prompt
        ld      (hl), $FF               ;
        ld      bc, 143                 ;
        ldir                            ;
        ld      hl, $0007       ;\
        ld      ($800C),hl      ;-set textpos
        ld      hl, &DelPrompt  ; relocation to get address of prompt
        call    D_ZT_STR        ; display the prompt
        ld      ix, cmdline     ; ix is where the string will be stored
        ld      c, 8            ; max len 8 characters
        ld      a, 16           ; set cursor type to ALPHA
        LIB_CALL_(1,0)          ; (USGDLIB,INPST)  ; string input function
        ld      a, ' '          ; HAH!
        call    TX_CHARPUT      ; no more ghost cursors
        res     3, (IY+05)
        ld      a, (IX)         ; check to see if exit was
        and     a               ; pressed during string input
        jr      z, NoDel
        ld      hl, cmdline
        call    VAR_DELETE
NoDel:
        pop     af
        ret

Cdir:
        push    af
        ld      hl, VAT_START-10   ; VAT_START skip Usgard
        sub     a
        ld      (counter), a
findloop:                          ; get data for next var in vat
        ld      a, $0C
        call    SEARCH_VAT
        jr      c, dir_quit
        ld      a, (de)
	and     a
        jr      nz, findloop
        inc     de
        ld      a, (de)
	cp      $FA
        jr      c, findloop
display:        ; show info
        push    hl
        call    &Nextline
        ld      hl, VATName
        call    D_ZM_STR
        ld      a, (counter)
        cp      $07
        jr      nz, no_reset
        call    OTH_PAUSE      ; pause
        sub     a
no_reset:
        inc     a
        ld      (counter), a
        pop     hl
        jr      findloop          ;loop again
dir_quit:         ; bye!
        pop     af
        ret                     


;;;;
;text strings
;;;;

Prompt:
.db "C:>",0
MEM_PROMPT:
.db " bytes free",0
DelPrompt:
.db "Delete:>",0

Error:             ;     | default error message
.db "String not found.",0

; Commands
DIR:
.db "D",0       ; DIR
CLS:
.db "C",0       ; CLS
OFF:
.db "O",0       ; OFF
DEL:
.db "R",0       ; DEL

;AUTO_NAME:
;.db "AUTOEXEC",0
QVIEW:
.db "qview",0
.end

